import string
import types
import re
import os

debug=0

comments={ 'shell':'#', 'shell_env':'#' }
patterns={}
patterns['shell']=r'\s*(?P<comment>#?)\s*(?P<variable>\b\w+\b)=(?P<value>\S*(?:\s*[^\s#]+)*)(?:\s*)|(?:\s+#.*)$'
patterns['shell_env']=r'\s*(?P<comment>#?)\s*export\s+(?P<variable>\b\w+\b)=(?P<value>\S*(?:\s*[^\s#]+)*)(?:\s*)|(?:\s+#.*)$'
patterns['keywords']=r'\s*(?!#)(?P<variable>\b\w+\b)\s+(?P<value>\S*(?:\s*[^\s#]+)*)(?:\s*)|(?:\s+#.*)$'
new_entries={ 'shell'    :'<comment><name>=<value>\n',\
              'shell_env':'<comment>export <name>=<value>\n'}


def init_params(params):
    type=params['config_file_type']
    
    if not params.has_key('comment') and comments.has_key(type):
        params['comment']=comments[type]
    if not params.has_key('pattern'):
        params['pattern']=re.compile(patterns[type])
    else:
        params['pattern']=re.compile(params['pattern'])
    if not params.has_key('new_entry'):
        params['new_entry']=new_entries[type]
    

def set_value_entry(entry, value):
    entry['value']=value
    if entry.has_key('value_type') and entry['value_type']=='list':
	for i in entry['list_values']:
	    if type(i)==types.TupleType and i[1]==entry['value']:
		entry['value']=i[0]

def match_read(s, parameters, entries):
    
    m=parameters['pattern'].match(s)
    try:
	if m:
	    for i in entries.keys():
		if m.group('variable')==entries[i]['config_name']:
		    if m.groupdict().has_key('comment'):
			if not m.group('comment'):   
			    entries[i]['_active']=1    # entry not commented
			    set_value_entry(entries[i],m.group('value'))
			elif not entries[i].has_key('_active') or \
			     entries[i]['_active']==0:    
			    entries[i]['_active']=0    # entry commented
			    set_value_entry(entries[i],m.group('value'))
		    else:
			set_value_entry(entries[i],m.group('value'))
			
    except KeyError, p:
	print "Error: cannot find mandatory parameter '"+p.args[0]+"' for entry '"+\
	      i+"'"
	print "in description file "+parameters['desc_file_name']+"."
	raise SystemExit, 7
	

def read_file(parameters):
    try:
	file=parameters[0]['config_file_name']
        if string.strip(file)[0:2]=='~/':
            file=string.replace(file,'~',os.environ['HOME'],1)
            parameters[0]['config_file_name']=file
	f=open(file, 'r')
	line=f.readline()
	while line != '':
	    match_read(line, parameters[0], parameters[1])
	    line=f.readline()
	f.close()
    except KeyError, p:
	print "Error: cannot find mandatory parameter '"+p.args[0]+"'"
	print "in description file "+parameters[0]['desc_file_name']+"."
	raise SystemExit, 7
    except IOError, m:
	print "Error in reading description file:"
	print m
	raise SystemExit, 6

def match_write(s, parameters, entries):
    
    p=parameters['pattern']
    m=p.match(s)
    if m:
	for i in entries.keys():
	    if m.group('variable')==entries[i]['config_name']:
                if (entries[i].has_key('presence') and \
                    entries[i]['presence']=='optional'):
                    if entries[i]['_active']:
                        c=''
                    else:
                        c=parameters['comment']
                    if debug:
                        print m.group('variable'),c
                    s=s[0:m.start('comment')]+c+\
                       s[m.end('comment'):m.start('value')]+\
                       entries[i]['value']+s[m.end('value'):]
                else:
                    s=s[0:m.start('value')]+entries[i]['value']+s[m.end('value'):]
		entries[i]['_written']=1
    return s

def create_entry(config, entry):
    new_entry=config['new_entry']
    new_entry=string.replace(new_entry,'<name>',entry['config_name'])
    new_entry=string.replace(new_entry,'<value>',entry['value'])
    c=''
    if (entry.has_key('presence') and \
        entry['presence']=='optional' and \
        not entry['_active']):
            c=config['comment']
    if config.has_key('comment'):
        new_entry=string.replace(new_entry,'<comment>',c)

    return new_entry

def write_file(parameters):
    config=parameters[0]
    entries=parameters[1]
    fileout=config['config_file_name']
    filein=fileout+'.bak'
    os.rename(fileout,filein)
    fin=open(filein, 'r')
    fout=open(fileout, 'w')
    line=fin.readline()
    while line != '':
	fout.write(match_write(line, config, entries))
	line=fin.readline()
    for entry in entries.keys():
	if not entries[entry].has_key('_written') or not entries[entry]['_written']:
            if debug:
                print entry
	    fout.write(create_entry(config, entries[entry]))
    fin.close()
    fout.close()

