#!/usr/bin/env python

#    installer fo LUCI
#    Copyright (C) 1999 J\xe9r\xf4me SAUTRET (jerome@linuxfan.com)
#                                                                
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or   
#    (at your option) any later version.                              
#                                      
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details.                 
#                                               
#    You should have received a copy of the GNU General Public License
#    along with this program; see the file COPYING.  If not, write to 
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#    Boston, MA 02111-1307, USA.


import string, os, shutil, stat, compileall

default_prefix="/usr/local"
program="luci"
modules=['desc','gui','file']

print """
This program will install LUCI on your system.

Choose a prefix for the location installation. LUCI modules will
be installed in PREFIX/lib/luci and the LUCI executable will be
copied in PREFIX/bin. Just press enter to accept""", default_prefix, """ as
a default prefix.
"""
prefix=raw_input("Enter a prefix ["+default_prefix+"]:")

if string.strip(prefix)=="":
    prefix=default_prefix
else:
    prefix=os.path.abspath(prefix)

moduledir=prefix+"/lib/luci"
bindir=prefix+"/bin"

if not os.path.isdir(bindir):
    os.makedirs(bindir)
if not os.path.isdir(moduledir):
    os.makedirs(moduledir)

moduledir=moduledir+"/"
bindir=bindir+"/"


print "Installing "+program+" in "+bindir+" ..."
try:
    fin=open(program, "r")
except IOError:
    print "Can't open "+program+" file for reading, aborting."
    raise SystemExit, 1
try:
    fout=open(bindir+program, "w")
except IOError:
    print "Can't create "+bindir+program+", aborting."
    raise SystemExit, 2

for line in fin.readlines():
    fout.write(string.replace(line, "luci_module_path='/usr/local/lib/luci'",
                              "luci_module_path='"+moduledir+"'"))

fin.close()
fout.close()

# set executable
os.chmod(bindir+program, stat.S_IMODE(os.stat(bindir+program)[0]) | 0111)

print "Installing modules in "+moduledir+" ..."
for module in modules:
    module=module+'.py'
    shutil.copyfile(module, moduledir+module)

compileall.compile_dir(moduledir)

print """
LUCI is now installed.
To uninstall, type:
rm""", bindir+program,"&& rm -r",moduledir
print
